#!/usr/bin/perl -w

#02/22/2000
#conserved residues per site in the alignment

#modified 12/14/2001
#
#calculating averages: different from previous versions - now it averages with middle point
#of the interval presenting the average sum (so it averages over average+1)
#also prints out coordinate x along with coordinate y

#Wed Nov  8 10:24:08 2006
#original Java code was transferred into Perl Code

#written by Olga Zhaxybayeva


unless(@ARGV==2) {die "Usage: alignment_conservation.pl filename window_size-1\n\nfilename should contain alignment in FASTA one-line format.\nwindow_size-1 must be an even number(0,2,...)\n";}

$infile=$ARGV[0];
$average=$ARGV[1];


#read alignment in
$numSeqs=0;
@seqs=();
open(IN, "< $infile") or die "cannot open $infile\n";
L: while(defined($line=<IN>)){

    if($line=~">"){
    
	next L;
    
    }
    else{
    
	chomp($line);
	$seqs[$numSeqs]=$line;
	$numSeqs++;
    
    }

}

close(IN);
$numSites=length($seqs[0]);

$outfile=$infile.".".$average.".out";
open(OUT, "> $outfile") or die "cannot open $outfile\n";

$outfile2="$infile.seq";
open(OUT2, "> $outfile2") or die "cannot open $outfile2\n";

@sum=();
   
#look at each site of the alignment

$count=0; #counts how many positions included in the analyses
for($i=0;$i<$numSites;$i++){

    @aa=(); #presence(1) or absence(0) of each amino acid at a site
    
    $gap=0; #flag for gap present in > 50% sites
    $gapsN=0; #gaps counter

     
    for($k=0;$k<20;$k++){
	
	$aa[$k]=0;
	
    }

    $sum[$i]=0;

    L2: for($j=0;$j<$numSeqs;$j++){
    
	$datum=substr($seqs[$j],$i,1);
	if($datum eq "A"){
	
	    $aa[0]=1;
	
	}
	elsif($datum eq "C"){
	
	    $aa[1]=1;
	
	}
	elsif($datum eq "D"){
	
	    $aa[2]=1;
	
	}elsif($datum eq "E"){
	
	    $aa[3]=1;
	
	}elsif($datum eq "F"){
	
	    $aa[4]=1;
	
	}elsif($datum eq "G"){
	
	    $aa[5]=1;
	
	}elsif($datum eq "H"){
	
	    $aa[6]=1;
	
	}elsif($datum eq "I"){
	
	    $aa[7]=1;
	
	}elsif($datum eq "K"){
	
	    $aa[8]=1;
	
	}elsif($datum eq "L"){
	
	    $aa[9]=1;
	
	}elsif($datum eq "M"){
	
	    $aa[10]=1;
	
	}elsif($datum eq "N"){
	
	    $aa[11]=1;
	
	}elsif($datum eq "P"){
	
	    $aa[12]=1;
	
	}elsif($datum eq "Q"){
	
	    $aa[13]=1;
	
	}elsif($datum eq "R"){
	
	    $aa[14]=1;
	
	}elsif($datum eq "S"){
	
	    $aa[15]=1;
	
	}elsif($datum eq "T"){
	
	    $aa[16]=1;
	
	}elsif($datum eq "V"){
	
	    $aa[17]=1;
	
	}elsif($datum eq "W"){
	
	    $aa[18]=1;
	
	}elsif($datum eq "Y"){
	
	    $aa[19]=1;
	
	}elsif($datum eq "-"){
	
	    $gapsN++;if ($gapsN>=$numSeqs/2) {$gap=1; $sum[$i]=0; last L2;} # if in a position 50% are gaps, the position is excluded from further analyses
	
	}
	else{
	
	    die "some strange characters encountered in the alignment: sequence $j, site $i, symbol $datum\n";
	
	
	}
    
    }
    
    if($gap==0){
    
	for($k=0;$k<20;$k++){
	
	    $sum[$i]+=$aa[$k];
	
	}
	if($gapsN>0)
	 { $sum[$i]+=1;}
	$count++; #counts how many positions included in the analyses
   
   if($gap==1){
    $sum[$i]=0;}
   
   }
#$count++;
}



#calculating averages: different from previous versions - now it averages with middle point
#of the interval presenting the average sum

for($i=$average/2;$i<@sum-$average/2;$i++){
    $total=$sum[$i];
    $decrease=0;
    
        if($sum[$i]==0)
       {$decrease+=1};
    
    for($j=1;$j<=$average/2;$j++){
	$total+=$sum[$i+$j];
	$total+=$sum[$i-$j];
    

    
    if($sum[$i+$j]==0)
    {$decrease+=1};
    
    if($sum[$i-$j]==0)
    {$decrease+=1};
    
    }  
		   

 if($decrease>$average/2){
 $total=-1;}
		   
    if($decrease<=$average/2){
    
    $total=1.0*$total/($average+1-$decrease);}
    print OUT $i+1,"\t$total\n";
}


close(OUT);
close(OUT2);

		
###################
    
		
